/*
 * SETA43
 * PULSO
 * xsetaseta@gmail.com
 */


#define VISUAL

#define DIFE 1
#define VELOCIDAD  10
#define PROPORCION  10000

int sensorPin = A0;   
int ledPin = 13;      
int Vol,Volx, Volz; 


int Dmax, Dmin, Dmed, Ddif;

int z, d;
int neg, cn, pos, cp;


bool cambio;
int latidos;
bool latido, latidoz;
int nPulsos;
int tiempo,tiempoz;


const int pinBuzzer = 9;

void setup()
{
  pinMode(ledPin, OUTPUT);
  Serial.begin(115200);
  Serial.println("---PROGRAMA PULSOS--- ");
  nPulsos = 80;
  latidos = 0;
}


void loop()
{

//Lectura y filtro
  Volz = Vol;
  Vol = analogRead(sensorPin);
  Volx = Vol;                   //guardar original
  if (Vol > 800)Vol = 800;

  Vol +=  Volz;   Vol /= 2;     // Hace la media de dos medidas, suaviza onda
//_____________________________________

  d = Volz - Vol;

  if (d < 0)
  {
    neg = neg + d;
    cn++;
    pos = 0; cp = 0;   cambio = 0;
  }
  else
  {
    pos = pos + d;
    cp++;
    neg = 0; cn = 0;   cambio = 1;  
  }


  if ((neg / cn) < -1 && cn > 5)
    { latido = 1;  }
    else
  {  if ((pos / cp) >= 0 && cp > 5)       latido = 0;  }


  if (latido != latidoz)
  {
    if (latido)
    {
      tone(pinBuzzer, 440);      digitalWrite(ledPin, 1);
      latidos=PROPORCION/(tiempo+tiempoz);
#ifdef  VISUAL
#else
  Serial.print("1   Latidos="); Serial.println(latidos);
#endif 
    tiempoz=tiempo; 
    tiempo = 0;    
    }
    else
    {
      noTone(pinBuzzer);      digitalWrite(ledPin, 0);
      tiempo = 0;
#ifdef  VISUAL
#else
  Serial.println("0");
#endif          
    }
  }
  
  latidoz = latido;       //Guarda estado latido


#ifdef  VISUAL
  Serial.print(" "); Serial.print(Volx);   //Original
//  Serial.print(" "); Serial.print(Volz);  //Suavizada
  Serial.print(" "); Serial.print(latidos);  //latidos
  Serial.print(" "); Serial.println(550);   //Para que no cambie la escala

#endif

  tiempo++;
   if(tiempo>8) noTone(pinBuzzer);
  if (tiempo > 200)
  {
    tiempo = 0;
    nPulsos = 80;
    Serial.println("ERROR...");
  }
  delay(VELOCIDAD);
}



